/**
 * Mutton.java
 *
 * 
 */



import java.awt.*;
import com.sun.j3d.utils.geometry.Sphere;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Mutton extends SphereThing {
	static Mutton [] theMuttons = new Mutton [Env.maxThings];	// array holding all plasmids
	static int muttonCt = 0;			//
	static Object muttonSyncO = new Object();		// Object for safe addition/removal of Muttons
	int muttonNumber;
	Color muttonColor = Color.red;	// color for drawing
	
	public Mutton (Pt3D initCoord) {
		super(initCoord,Env.muttonRadius.getValue());
		addMutton(this);
		ambientC = new Color3f(muttonColor);
		diffuseC = new Color3f(muttonColor);
	}
	
	public static void makeInitialMuttons () {
		for (int i=0;i<Env.initialMuttons.getValue();i++) {
			makeRandomMutton();
		}
	}
	
	public static void spawnMuttons () {
		if (Env.mtRNG.raw() < Env.muttonSpawnRate.getValue()*Env.deltaT.getValue()) {
			makeRandomMutton();
		}
	}
		
	public static void makeRandomMutton () {
		Pt3D randomLoc = Thing.theSphere.rdmPtInsideBug(Env.muttonRadius.getValue());
		new Mutton (randomLoc);
	}
	
	public static void addMutton (Mutton newMutton) {
		synchronized (muttonSyncO) {
			theMuttons[muttonCt] = newMutton;
			theMuttons[muttonCt].muttonNumber = muttonCt;
			muttonCt++;
		}
	}
	
	public void swapOut () {
		super.swapOut();
		synchronized (muttonSyncO) {
			int swapId = muttonNumber;
			theMuttons[swapId] = theMuttons[muttonCt-1];
			theMuttons[swapId].muttonNumber = swapId;
			theMuttons[muttonCt-1] = null;
			muttonCt--;
		}
	}
	
	public void nullify () {
		super.nullify();
		muttonColor = null;
	}

}